function open_estate_form(x, form, d) {
  let row = $(x).closest(".collection-item");
  let pageid = row.parent().attr("data-pageid");
  loadSelection(row, pageid, "new_form"+pageid, "modal");
}

function trigger_tags (thx) {
  let element = $(thx);
  let data = element.data();
  let val = element.val();
  let form = element.closest("form");
  let source = form.prop("param");
  if(source){
    source = source.all;
    // $("#"+data.pageid+" .widget-selector").closest(".json-container").empty().init_objectWidget(source[val]);
  }
}

function showExpDate(thx) {
  let element = $(thx);
  let form = element.closest("form");
  let pageid = element.attr("data-pageid");
  if(element.is(":checked")){
    form.find("#date_closing"+pageid).attr({disabled:false}).parent().removeClass("hide");
  }else{
    form.find("#date_closing"+pageid).attr({disabled:true}).parent().addClass("hide");
  }
}
function sendmessage(thx) {
  let element = $(thx);
  let form = element.closest("form");
  let pageid = element.attr("data-pageid");
  if(element.val() != 1){
    form.find("#comment"+pageid).attr({disabled:false}).parent().removeClass("hide");
    form.find("#promoted"+pageid).attr({disabled:true}).val(0).trigger("change").parent().addClass("hide");
  }else{
    form.find("#comment"+pageid).attr({disabled:true}).parent().addClass("hide");
    form.find("#promoted"+pageid).attr({disabled:false}).parent().removeClass("hide");
  }
}

function fetchproperty(thx) {
  let form = $(thx);
  let data = form.data();
  let container = form.find(".widget-container");
  let param = form.prop("param");
  let conparam = container.prop("param");

  if(!param){
    param = conparam;
    param.all = conparam.resetable;
    param.resetable = conparam.resetable[Object.keys(conparam.resetable)[0]];
  }

  param.current = conparam.current;

  console.log(param);

  if(typeof(Object.values(param.current)[0]) !== "string"){
    container.loadObjectWidget(param.resetable);
    $("#pcategories"+data.pageid).attr({disabled:false});
  }else{
    $("#pcategories"+data.pageid).attr({disabled:true});
  }

  form[0].param = param;
  // form.find("#status"+data.pageid).trigger("change");
}

function open_edit_store_category_form(x) {
  let row = $(x).closest(".collection-item");
  let pageid = row.parent().attr("data-pageid");
  loadSelection(row, pageid, "new_form"+pageid,"modal");
}

function open_edit_store(x) {
  let row = $(x).closest(".collection-item");
  let pageid = row.parent().attr("data-pageid");
  loadSelection(row, pageid, "new_form"+pageid,"modal");
}

function edit_form_modal(x) {
  let row = $(x).closest(".collection-item");
  let pageid = row.parent().attr("data-pageid");
  loadSelection(row, pageid, "new_form"+pageid,"swipe");
}

function open_ad_categories_filters(element, modal_id) {
  let data    = $(element).data();
  let modal   = $(`#${modal_id}`);
  let form    = modal.children("form");
  let pageid  = $(form).attr("data-pageid");
  $(form).attr({"data-value":data.id}).find(`#form_title${pageid}`).text($(element).closest("a").data("title"));
  $(form).find(`#parent${pageid}`).val(data.id);
  $(form).find(`#pagetype${pageid}`).attr({name:"pageType"});

  // Create a name=parent element inside the inner form
  if(!$(form).find("#parent-list").length){
    $(form).find(".list-container .dynamic-lists-body form").append($("<input>").attr({name:"parent", id:"parent-list", type:"hidden"}));
  }
  // Populate the select box and load the first one
  let groups = $(form).find(`#groups${pageid}`)
  let source = groups.data("source") + "~parent";
  let send = {
    groups:{
      source: source,
      value: data.id
    }
  };
  groups.next(`label`).startLoader();
  $.post(`${site.backend}process/dropdown`, send, function (response) {
    groups.next(`label`).stopLoader()
    let res = isJson(response);
    if(res.groups){
      groups.empty();
      $.each(res.groups, function (i, v) {
        groups.append($("<option>").attr({value:i}).text(v));
      });
      groups[0].selectedIndex = 0;
      $(form).find(".list-container .dynamic-lists-body").attr({"data-value":groups.val()});
      $(form).find(`#parent-list`).val(groups.val()).attr({value:groups.val()});
      groups.change();
    }
  })
  modal.openModal();
}

function load_lists(groups) {
  let form    = $(groups).closest("form");
  let pageid  = $(form).attr("data-pageid");
  $(form).find(".list-container .dynamic-lists-body").attr({"data-value":$(groups).val()});
  $(form).find(`#parent-list`).val($(groups).val());
  $(form).find(".dynamic-lists-body").reload_listManager();
  let desc = $(groups).find(`option[value=${$(groups).val()}]`).text();
  $(form).find(".dynamic-lists-head").text("Showing filter list for " + desc);
}

// Adds a new group
function add_group(element, $event) {
  let code = $event.which || $event.keyCode;
  let data    = $(element).data();
  let form    = $(element).closest("form");
  let pageid  = $(form).attr("data-pageid");
  if(code === 13){
    let formdata = form.serializeArray();
    console.log(formdata);
    $(element).next(`label`).startLoader()
    $.post(`${site.backend}process/saveform`, formdata, function (response) {
      $(element).next(`label`).stopLoader()
      let res = isJson(response);
      if(res.status){
        let newclass = $.grep(formdata, (obj)=>{return obj.name == "name";})[0].value;
        $(form).find(`#groups${pageid}`).append($("<option>").attr({value:res.primary_key}).text(newclass)).val(res.primary_key).change();
        $(element).val("");
      }
    })
  }
}

function get_this_group(element) {
  form = $(element);
  let data = form.serializeArray();
  data.push({name:"case", value:"attach-group"});
  let select = form.find("select");
  let value = select.val();
  select.empty().val([]).change();
  let instance = select.prop("instance");
  instance.destroy();
  $.post(`${site.backend}process/custom`, data, function (response) {
    let res = isJson(response);
    if(res.status){
      for(let i in res.data){
        let object = res.data[i];
        select.append($("<option>").text(object.name).attr({value:object.id}));
      }
      let instance = M.FormSelect.init(select[0]);
      select[0].instance = instance;
      select.val(value).change();
    }else{
      let message = res.message || "An Error Occured";
      M.toast({html:message, classes:"red", displayLength:2000});
      console.log(response);
    }
  });
}

function toggle_amount(element) {
  let data    = $(element).data();
  let card    = $(element).closest(".card");
  let pageid  = data.pageid;
  if($(element).is(":checked")){
    card.find("#amount"+pageid).attr({disabled:false, required:true}).parent().removeClass("hide");
  }else{
    card.find("#amount"+pageid).attr({disabled:true, required:false}).parent().addClass("hide");
  }
}

function toggle_duration(element) {
  let data    = $(element).data();
  let card    = $(element).closest(".card");
  let pageid  = data.pageid;
  if($(element).is(":checked")){
    $("#start_date"+pageid).attr({disabled:false, required:true}).parent().removeClass("hide");
    $("#stop_date"+pageid).attr({disabled:false, required:true}).parent().removeClass("hide");
  }else{
    $("#start_date"+pageid).attr({disabled:true, required:false}).parent().addClass("hide");
    $("#stop_date"+pageid).attr({disabled:true, required:false}).parent().addClass("hide");
  }
}

function intialize_inputs(form) {
  let data    = $(form).data();
  let pageid  = data.pageid;
  $("#duration"+pageid).trigger("change");
  if($("#amount"+pageid).val()){
    $("#free"+pageid).prop("checked", true);
  }
}
