<?php
// All currency codes must adhere to ISO_4217 currency codes.
// Visit https://en.wikipedia.org/wiki/ISO_4217#Active_codes to find out what this means
// Compiled by Clinton 27-02-2020

class ForExchange{
  // https://currencyapi.net API Key
  static $API_KEY = "3cd3572265af84592cdde1627551dce5f903";
  public $url_key = 0;
  public $rates;
  public $base;
  public $filename = "";

  public function __construct($base = "USD"){
    $this->base = $base;
    $generic = new Generic;
    $uri= $generic->getURIdata();
    $dir = absolute_filepath($uri->site)."cache/";
    $file = "{$dir}rates.json";
    $this->filename = $file;
  }

  private function getUrls(){
    // This is where you store Urls/APIs that deliver exchange rates,
    // The getRate() method searches the results from these APIs until it finds and exchange rate for a particular currency given
    //For currencyapi.net API, 'base' parameter is fixed to USD because it's a free account (1250 requests), next affordable plan is $ 99.99 for (12500 Monthly requests)
    $urls = [
      "",
      "https://api.exchangerate-api.com/v4/latest/{$this->base}",
      "https://currencyapi.net/api/v1/rates?key={$this::$API_KEY}&base=USD"
    ];
    return $urls;
  }

  // Get current currency rates
  public function rates($index = 0, $internal_call = false){
    if($index === 0){
      $this->url_key++;
      $url_key = $this->url_key;
    }else{
      $url_key = $index;
    }
    //see("$index $url_key, ", false);
    if(empty($this->rates) || $index > 0 || $internal_call){
      $response = new stdClass;
      $urls = $this->getUrls();
      if(!empty($urls[$url_key])){
        $response = file_get_contents($urls[$url_key]);
        $isjson = isJson($response);
        if($isjson != false){
          $this->rates = json_decode($response)->rates;
        }else return new stdClass;
      }else return new stdClass;
    }

    _writeFile($this->filename, $this->rates );
    return $this->rates;
  }

  //
  public function toBTC($currency_amount = 1){
    $response = 0;
    $url = [
      "url"=>"https://blockchain.info/tobtc?currency={$this->base}&value={$currency_amount}"
    ];
    $response = curl_post($url);
    return floatval($response);
  }

  // Get Rate of a particular currency
  public function getRate($currency ){
    $response = 0;
    $base  = $this->base;
    if($base == $currency)
      $rate = 1;
    else{
      if($this->url_key == 0){
        $rates = $this->getFromCache();
        // see($rates);
      } else {
        $rates = $this->rates(0, true);
      }
      // If currency is not in the rates move to the next one
      if(empty($rates->{$currency})){
        if($this->url_key <= (count($this->getUrls()) - 2)){
          $rate = $this->getRate($currency);
        }else{
          $rate = 0;
        }
      }else{
        $rate = round($rates->{$currency}, 2);
      }
    }

    return $rate;
  }

  public function getFromCache($createOnly=false){
    // Get from Cache
   $today = strtotime(date('Y-m-d h:i:s'));
   $dir = dirname($this->filename);
   if(!is_dir($dir)){ mkdir($dir, 0777, true);}
   if(file_exists($this->filename) && $createOnly !== true && (round(($today - filemtime($this->filename))/(3600*24)) < 3)){
      $rates = json_decode(_readFile($this->filename));
   }else{
      $rates = $this->rates(0, true);
   }
   return $rates;
  }
}
?>
